// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16SDI/16SDI_Linux_4.x.x.x_GSC_DN/include/16sdi_utils.h $
// $Rev: 51941 $
// $Date: 2022-10-25 08:26:45 -0500 (Tue, 25 Oct 2022) $

// 16SDI: Utilities: header file

#ifndef	__16SDI_UTILS_H__
#define	__16SDI_UTILS_H__

#include "16sdi_api.h"
#include "gsc_utils.h"
#include "gsc_utils_pci.h"



// prototypes *****************************************************************

// API utility services

int	sdi_close_util				(int fd, int index, int verbose);
int sdi_init_util				(int verbose);
int sdi_ioctl_util				(int fd, int index, int verbose, int request, void* arg);
int	sdi_open_util				(int device, int share, int index, int verbose, int* fd);
int	sdi_read_util				(int fd, int index, int verbose, void* dst, size_t bytes);

// IOCTL utility services

int	sdi_ain_buf_clear			(int fd, int index, int verbose);								// SDI_IOCTL_AIN_BUF_CLEAR
int	sdi_ain_buf_input			(int fd, int index, int verbose, s32 set, s32* get);			// SDI_IOCTL_AIN_BUF_INPUT
int sdi_ain_buf_thresh			(int fd, int index, int verbose, s32 set, s32* get);			// SDI_IOCTL_AIN_BUF_THRESH
int sdi_ain_buf_thresh_sts		(int fd, int index, int verbose, s32* get);						// SDI_IOCTL_AIN_BUF_THRESH_STS
int	sdi_ain_mode				(int fd, int index, int verbose, s32 set, s32* get);			// SDI_IOCTL_AIN_MODE
int	sdi_ain_range				(int fd, int index, int verbose, s32 set, s32* get);			// SDI_IOCTL_AIN_RANGE
int	sdi_auto_cal_status			(int fd, int index, int verbose, s32* get);						// SDI_IOCTL_AUTO_CAL_STATUS
int	sdi_auto_calibrate			(int fd, int index, int verbose);								// SDI_IOCTL_AUTO_CALIBRATE
int	sdi_ch_grp_0_src			(int fd, int index, int verbose, s32 set, s32* get);			// SDI_IOCTL_CH_GRP_0_SRC
int	sdi_ch_grp_1_src			(int fd, int index, int verbose, s32 set, s32* get);			// SDI_IOCTL_CH_GRP_1_SRC
int	sdi_ch_grp_2_src			(int fd, int index, int verbose, s32 set, s32* get);			// SDI_IOCTL_CH_GRP_2_SRC
int	sdi_ch_grp_3_src			(int fd, int index, int verbose, s32 set, s32* get);			// SDI_IOCTL_CH_GRP_3_SRC
int	sdi_channel_order			(int fd, int index, int verbose, s32 set, s32* get);			// SDI_IOCTL_CHANNEL_ORDER
int	sdi_channels_ready			(int fd, int index, int verbose, s32 set, s32* get);			// SDI_IOCTL_CHANNELS_READY
int	sdi_data_format				(int fd, int index, int verbose, s32 set, s32* get);			// SDI_IOCTL_DATA_FORMAT
int	sdi_init_mode				(int fd, int index, int verbose, s32 set, s32* get);			// SDI_IOCTL_INIT_MODE
int	sdi_initialize				(int fd, int index, int verbose);								// SDI_IOCTL_INITIALIZE
int	sdi_irq_sel					(int fd, int index, int verbose, s32 set, s32* get);			// SDI_IOCTL_IRQ_SEL
int	sdi_query					(int fd, int index, int verbose, s32 set, s32* get);			// SDI_IOCTL_QUERY
int	sdi_rate_div_00_ndiv		(int fd, int index, int verbose, s32 set, s32* get);			// SDI_IOCTL_RATE_DIV_00_NDIV
int	sdi_rate_div_01_ndiv		(int fd, int index, int verbose, s32 set, s32* get);			// SDI_IOCTL_RATE_DIV_01_NDIV
int	sdi_rate_div_02_ndiv		(int fd, int index, int verbose, s32 set, s32* get);			// SDI_IOCTL_RATE_DIV_02_NDIV
int	sdi_rate_div_03_ndiv		(int fd, int index, int verbose, s32 set, s32* get);			// SDI_IOCTL_RATE_DIV_03_NDIV
int	sdi_rate_div_04_ndiv		(int fd, int index, int verbose, s32 set, s32* get);			// SDI_IOCTL_RATE_DIV_04_NDIV
int	sdi_rate_div_05_ndiv		(int fd, int index, int verbose, s32 set, s32* get);			// SDI_IOCTL_RATE_DIV_05_NDIV
int	sdi_rate_div_06_ndiv		(int fd, int index, int verbose, s32 set, s32* get);			// SDI_IOCTL_RATE_DIV_06_NDIV
int	sdi_rate_div_07_ndiv		(int fd, int index, int verbose, s32 set, s32* get);			// SDI_IOCTL_RATE_DIV_07_NDIV
int	sdi_rate_div_08_ndiv		(int fd, int index, int verbose, s32 set, s32* get);			// SDI_IOCTL_RATE_DIV_08_NDIV
int	sdi_rate_div_09_ndiv		(int fd, int index, int verbose, s32 set, s32* get);			// SDI_IOCTL_RATE_DIV_09_NDIV
int	sdi_rate_div_10_ndiv		(int fd, int index, int verbose, s32 set, s32* get);			// SDI_IOCTL_RATE_DIV_10_NDIV
int	sdi_rate_div_11_ndiv		(int fd, int index, int verbose, s32 set, s32* get);			// SDI_IOCTL_RATE_DIV_11_NDIV
int	sdi_rate_div_12_ndiv		(int fd, int index, int verbose, s32 set, s32* get);			// SDI_IOCTL_RATE_DIV_12_NDIV
int	sdi_rate_div_13_ndiv		(int fd, int index, int verbose, s32 set, s32* get);			// SDI_IOCTL_RATE_DIV_13_NDIV
int	sdi_rate_div_14_ndiv		(int fd, int index, int verbose, s32 set, s32* get);			// SDI_IOCTL_RATE_DIV_14_NDIV
int	sdi_rate_div_15_ndiv		(int fd, int index, int verbose, s32 set, s32* get);			// SDI_IOCTL_RATE_DIV_15_NDIV
int	sdi_rate_gen_a_nrate		(int fd, int index, int verbose, s32 set, s32* get);			// SDI_IOCTL_RATE_GEN_A_NRATE
int	sdi_rate_gen_b_nrate		(int fd, int index, int verbose, s32 set, s32* get);			// SDI_IOCTL_RATE_GEN_B_NRATE
int	sdi_rate_gen_c_nrate		(int fd, int index, int verbose, s32 set, s32* get);			// SDI_IOCTL_RATE_GEN_C_NRATE
int	sdi_rate_gen_d_nrate		(int fd, int index, int verbose, s32 set, s32* get);			// SDI_IOCTL_RATE_GEN_D_NRATE
int	sdi_reg_mod					(int fd, int index, int verbose, u32 reg, u32 value, u32 mask);	// SDI_IOCTL_REG_MOD
int	sdi_reg_read				(int fd, int index, int verbose, u32 reg, u32* value);			// SDI_IOCTL_REG_READ
int	sdi_reg_write				(int fd, int index, int verbose, u32 reg, u32 value);			// SDI_IOCTL_REG_WRITE
int	sdi_rx_io_abort				(int fd, int index, int verbose, s32* get);						// SDI_IOCTL_RX_IO_ABORT
int	sdi_rx_io_mode				(int fd, int index, int verbose, s32 set, s32* get);			// SDI_IOCTL_RX_IO_MODE
int	sdi_rx_io_timeout			(int fd, int index, int verbose, s32 set, s32* get);			// SDI_IOCTL_RX_IO_TIMEOUT
int	sdi_sw_sync					(int fd, int index, int verbose);								// SDI_IOCTL_SW_SYNC
int	sdi_sw_sync_mode			(int fd, int index, int verbose, s32 set, s32* get);			// SDI_IOCTL_SW_SYNC_MODE
int	sdi_wait_cancel				(int fd, int index, int verbose, gsc_wait_t* wait);				// SDI_IOCTL_WAIT_CANCEL
int	sdi_wait_event				(int fd, int index, int verbose, gsc_wait_t* wait);				// SDI_IOCTL_WAIT_EVENT
int	sdi_wait_status				(int fd, int index, int verbose, gsc_wait_t* wait);				// SDI_IOCTL_WAIT_STATUS

// Auxiliary utility services

int	sdi_ch_grp_src_all			(int fd, int index, int verbose, s32 set);
int	sdi_ch_grp_src_group		(int fd, int index, int verbose, int group, s32 set, s32* get);
int	sdi_config_ai				(int fd, int index, int verbose, s32 fsamp);
int	sdi_fsamp_ai_compute		(int fd, int index, int verbose, s32 fsamp, s32* nrate, s32* ndiv, double* rate);
int	sdi_fsamp_ai_report			(int fd, int index, int verbose, int chan, s32* fsamp);				// sdi_channel_sample_rate
int	sdi_fsamp_ai_report_all		(int fd, int index, int verbose, s32* fsamp);
int	sdi_id_device				(int fd, int index, int verbose);
int	sdi_rate_div_ndiv_all		(int fd, int index, int verbose, s32 set);
int	sdi_rate_div_ndiv_chan		(int fd, int index, int verbose, int chan, s32 set, s32* get);
int	sdi_rate_gen_nrate_all		(int fd, int index, int verbose, s32 set);
int	sdi_rate_gen_nrate_rate_gen	(int fd, int index, int verbose, int rate_gen, s32 set, s32* get);

int	sdi_count_boards			(int verbose, s32* get);
int	sdi_reg_list				(int fd, int detail);

const gsc_reg_def_t*			sdi_reg_get_def_id			(u32 reg);
const gsc_reg_def_t*			sdi_reg_get_def_index		(int index);
const char*						sdi_reg_get_desc			(u32 reg);
const char*						sdi_reg_get_name			(u32 reg);



#endif
