// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16SDI/16SDI_Linux_4.x.x.x_GSC_DN/samples/fsamp/perform.c $
// $Rev: 50369 $
// $Date: 2022-02-15 16:57:02 -0600 (Tue, 15 Feb 2022) $

// 16SDI: Sample Application: source file

#include "main.h"



// macros *********************************************************************

#define	FILE_NAME				"fsamp.txt"



//*****************************************************************************
int perform_tests(const args_t* args)
{
	int		errs	= 0;
	FILE*	file	= NULL;
	int		fsamp;
	s32		max		= 0;
	s32		min		= 0;
	s32		ndiv;
	s32		nrate;
	double	rate;

	gsc_label("Fsamp Computation");
	printf("\n");
	gsc_label_level_inc();

	if (args->range == 0)
	{
		min		= args->fsamp;
		max		= args->fsamp;
	}
	else
	{
		errs	+= sdi_query(args->fd, -1, 0, SDI_QUERY_FSAMP_MAX, &max);
		errs	+= sdi_query(args->fd, -1, 0, SDI_QUERY_FSAMP_MIN, &min);
	}

	if (args->save)
	{
		file	= fopen(FILE_NAME, "w+b");

		if (file == NULL)
		{
			printf("FAIL <---  (unable to create %s)\n", FILE_NAME);
			errs	= 1;
		}
		else
		{
			fprintf(file, "# 16SDI Scan Rates\n");
			fprintf(file, "# Request   Produced\n");
			fprintf(file, "# ========  ==========\n");
		}
	}

	for (fsamp = min; fsamp <= max; fsamp++)
	{
		errs	+= sdi_fsamp_ai_compute(args->fd, -1, 1, fsamp, &nrate, &ndiv, &rate);

		if (file)
			fprintf(file, "%10ld  %10.3f\n", (long) fsamp, (float) rate);
	}

	if (file)
		fclose(file);

	gsc_label_level_dec();
	return(errs);
}


