// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16SDI/16SDI_Linux_4.x.x.x_GSC_DN/samples/sbtest/ain_range.c $
// $Rev: 51952 $
// $Date: 2022-10-25 08:36:47 -0500 (Tue, 25 Oct 2022) $

// 16SDI: Sample Application: source file

#include "main.h"



/******************************************************************************
*
*	Function:	ain_range_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service SDI_IOCTL_AIN_RANGE.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int ain_range_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_IOCTL_SET,
			/* cmd		*/	SDI_IOCTL_INITIALIZE,
			/* arg		*/	0,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},

		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	SDI_IOCTL_AIN_RANGE,
			/* arg		*/	SDI_AIN_RANGE_1_25V,
			/* reg		*/	SDI_GSC_BCR,
			/* mask		*/	0xC,
			/* value	*/	0x0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	SDI_IOCTL_AIN_RANGE,
			/* arg		*/	SDI_AIN_RANGE_2_5V,
			/* reg		*/	SDI_GSC_BCR,
			/* mask		*/	0xC,
			/* value	*/	0x4
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	SDI_IOCTL_AIN_RANGE,
			/* arg		*/	SDI_AIN_RANGE_5V,
			/* reg		*/	SDI_GSC_BCR,
			/* mask		*/	0xC,
			/* value	*/	0x8
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	SDI_IOCTL_AIN_RANGE,
			/* arg		*/	SDI_AIN_RANGE_10V,
			/* reg		*/	SDI_GSC_BCR,
			/* mask		*/	0xC,
			/* value	*/	0xC
		},

		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	SDI_IOCTL_AIN_RANGE,
			/* arg		*/	SDI_AIN_RANGE_1_25V,
			/* reg		*/	SDI_GSC_BCR,
			/* mask		*/	0xC,
			/* value	*/	0x0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	SDI_IOCTL_AIN_RANGE,
			/* arg		*/	SDI_AIN_RANGE_2_5V,
			/* reg		*/	SDI_GSC_BCR,
			/* mask		*/	0xC,
			/* value	*/	0x4
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	SDI_IOCTL_AIN_RANGE,
			/* arg		*/	SDI_AIN_RANGE_5V,
			/* reg		*/	SDI_GSC_BCR,
			/* mask		*/	0xC,
			/* value	*/	0x8
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	SDI_IOCTL_AIN_RANGE,
			/* arg		*/	SDI_AIN_RANGE_10V,
			/* reg		*/	SDI_GSC_BCR,
			/* mask		*/	0xC,
			/* value	*/	0xC
		},

		{
			/* service	*/	SERVICE_IOCTL_SET,
			/* cmd		*/	SDI_IOCTL_INITIALIZE,
			/* arg		*/	0,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},

		{ SERVICE_END_LIST }
	};

	int	errs;

	gsc_label("SDI_IOCTL_AIN_RANGE");
	errs	= service_ioctl_set_reg_list(fd, list);

	if (errs == 0)
		errs	= service_ioctl_reg_get_list(fd, list);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


