// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16SDI/16SDI_Linux_4.x.x.x_GSC_DN/samples/sbtest/channel_order.c $
// $Rev: 51952 $
// $Date: 2022-10-25 08:36:47 -0500 (Tue, 25 Oct 2022) $

// 16SDI: Sample Application: source file

#include "main.h"



/******************************************************************************
*
*	Function:	channel_order_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service SDI_IOCTL_CHANNEL_ORDER.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int channel_order_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_IOCTL_SET,
			/* cmd		*/	SDI_IOCTL_INITIALIZE,
			/* arg		*/	0,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},

		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	SDI_IOCTL_CHANNEL_ORDER,
			/* arg		*/	SDI_CHANNEL_ORDER_ASYNC,
			/* reg		*/	SDI_GSC_BCR,
			/* mask		*/	0x10000,
			/* value	*/	0x00000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	SDI_IOCTL_CHANNEL_ORDER,
			/* arg		*/	SDI_CHANNEL_ORDER_SYNC,
			/* reg		*/	SDI_GSC_BCR,
			/* mask		*/	0x10000,
			/* value	*/	0x10000
		},

		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	SDI_IOCTL_CHANNEL_ORDER,
			/* arg		*/	SDI_CHANNEL_ORDER_ASYNC,
			/* reg		*/	SDI_GSC_BCR,
			/* mask		*/	0x10000,
			/* value	*/	0x00000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	SDI_IOCTL_CHANNEL_ORDER,
			/* arg		*/	SDI_CHANNEL_ORDER_SYNC,
			/* reg		*/	SDI_GSC_BCR,
			/* mask		*/	0x10000,
			/* value	*/	0x10000
		},

		{
			/* service	*/	SERVICE_IOCTL_SET,
			/* cmd		*/	SDI_IOCTL_INITIALIZE,
			/* arg		*/	0,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},

		{ SERVICE_END_LIST }
	};

	int	errs;

	gsc_label("SDI_IOCTL_CHANNEL_ORDER");
	errs	= service_ioctl_set_reg_list(fd, list);

	if (errs == 0)
		errs	= service_ioctl_reg_get_list(fd, list);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


