// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16SDI/16SDI_Linux_4.x.x.x_GSC_DN/samples/sbtest/irq_sel.c $
// $Rev: 51952 $
// $Date: 2022-10-25 08:36:47 -0500 (Tue, 25 Oct 2022) $

// 16SDI: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_IOCTL_SET,
			/* cmd		*/	SDI_IOCTL_INITIALIZE,
			/* arg		*/	0,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	SDI_IOCTL_IRQ_SEL,
			/* arg		*/	SDI_IRQ_INIT_DONE,
			/* reg		*/	SDI_GSC_BCR,
			/* mask		*/	0x700,
			/* value	*/	0x000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	SDI_IOCTL_IRQ_SEL,
			/* arg		*/	SDI_IRQ_AUTO_CAL_DONE,
			/* reg		*/	SDI_GSC_BCR,
			/* mask		*/	0x700,
			/* value	*/	0x100
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	SDI_IOCTL_IRQ_SEL,
			/* arg		*/	SDI_IRQ_CHANNELS_READY,
			/* reg		*/	SDI_GSC_BCR,
			/* mask		*/	0x700,
			/* value	*/	0x200
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	SDI_IOCTL_IRQ_SEL,
			/* arg		*/	SDI_IRQ_BUF_THRESH_L2H,
			/* reg		*/	SDI_GSC_BCR,
			/* mask		*/	0x700,
			/* value	*/	0x300
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	SDI_IOCTL_IRQ_SEL,
			/* arg		*/	SDI_IRQ_BUF_THRESH_H2L,
			/* reg		*/	SDI_GSC_BCR,
			/* mask		*/	0x700,
			/* value	*/	0x400
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	SDI_IOCTL_IRQ_SEL,
			/* arg		*/	SDI_IRQ_BUF_AE,
			/* reg		*/	SDI_GSC_BCR,
			/* mask		*/	0x700,
			/* value	*/	0x500
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	SDI_IOCTL_IRQ_SEL,
			/* arg		*/	SDI_IRQ_BUF_AF,
			/* reg		*/	SDI_GSC_BCR,
			/* mask		*/	0x700,
			/* value	*/	0x600
		},

		{ SERVICE_END_LIST }
	};

	int errs	= 0;

	errs	+= service_ioctl_set_reg_list(fd, list);
	errs	+= service_ioctl_reg_get_list(fd, list);

	errs	+= service_ioctl_set_reg_list(fd, list);
	errs	+= service_ioctl_reg_get_list(fd, list);

	return(errs);
}



//*****************************************************************************
static int _function_test(void)
{
	// The interrupts are tested via the Wait Event services.
	return(0);
}



/******************************************************************************
*
*	Function:	irq_sel_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service SDI_IOCTL_IRQ_SEL.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int irq_sel_test(int fd)
{
	int	errs	= 0;

	gsc_label("SDI_IOCTL_IRQ_SEL");
	errs	+= _service_test(fd);
	errs	+= _function_test();

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}



