// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16SDI/16SDI_Linux_4.x.x.x_GSC_DN/samples/sbtest/main.h $
// $Rev: 50367 $
// $Date: 2022-02-15 16:56:05 -0600 (Tue, 15 Feb 2022) $

// 16SDI: Sample Application: header file

#ifndef	__MAIN_H__
#define	__MAIN_H__

#include <errno.h>
#include <semaphore.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "16sdi_main.h"



// macros *********************************************************************

#define	SIZEOF_ARRAY(a)			(sizeof((a))/sizeof((a)[0]))



// data types *****************************************************************

typedef enum
{
	SERVICE_END_LIST,	// Ends list of service_data_t structures.
	SERVICE_NORMAL,
	SERVICE_REG_MOD,
	SERVICE_REG_TEST,
	SERVICE_REG_SHOW,
	SERVICE_SLEEP,
	SERVICE_SLEEP_MS,
	SERVICE_IOCTL_GET,
	SERVICE_IOCTL_SET
} service_t;

typedef struct
{
	service_t		service;
	unsigned long	cmd;	// IOCTL code
	s32				arg;	// The IOCTL data argument.
	u32				reg;	// The register to access. Use -1 to ignore.
	u32				mask;	// The register bits of interest.
	u32				value;	// The value expected for the bits of interest.
} service_data_t;



// prototypes *****************************************************************

int	ain_buf_clear_test(int fd);
int	ain_buf_input_test(int fd);
int	ain_buf_threshold_test(int fd);
int	ain_mode_test(int fd);
int	ain_range_test(int fd);
int	auto_calibrate_test(int fd);

int	channel_group_0_source_test(int fd);
int	channel_group_1_source_test(int fd);
int	channel_group_2_source_test(int fd);
int	channel_group_3_source_test(int fd);
int	channel_order_test(int fd);

int	data_format_test(int fd);

int	init_mode_test(int fd);
int	initialize_test(int fd);
int	irq_sel_test(int fd);					// SDI_IOCTL_IRQ_SEL

int	perform_tests(int fd);

int	query_test(int fd);

int	rate_div_00_ndiv_test(int fd);
int	rate_div_01_ndiv_test(int fd);
int	rate_div_02_ndiv_test(int fd);
int	rate_div_03_ndiv_test(int fd);
int	rate_div_04_ndiv_test(int fd);
int	rate_div_05_ndiv_test(int fd);
int	rate_div_06_ndiv_test(int fd);
int	rate_div_07_ndiv_test(int fd);
int	rate_div_08_ndiv_test(int fd);
int	rate_div_09_ndiv_test(int fd);
int	rate_div_10_ndiv_test(int fd);
int	rate_div_11_ndiv_test(int fd);
int	rate_div_12_ndiv_test(int fd);
int	rate_div_13_ndiv_test(int fd);
int	rate_div_14_ndiv_test(int fd);
int	rate_div_15_ndiv_test(int fd);
int	rate_gen_a_nrate_test(int fd);
int	rate_gen_b_nrate_test(int fd);
int	rate_gen_c_nrate_test(int fd);
int	rate_gen_d_nrate_test(int fd);
int	reg_mod_test(int fd);
int	reg_read_test(int fd);
int	reg_write_test(int fd);
int	rx_io_abort_test(int fd);				// SDI_IOCTL_RX_IO_ABORT
int	rx_io_mode_test(int fd);
int	rx_io_timeout_test(int fd);

int	service_ioctl_reg_get_list(int fd, const service_data_t* list);
int	service_ioctl_set_get_list(int fd, const service_data_t* list);
int	service_ioctl_set_reg_list(int fd, const service_data_t* list);
int	sw_sync_mode_test(int fd);
int	sw_sync_test(int fd);

int	voltage_test(int fd);

int	wait_cancel_test(int fd);				// SDI_IOCTL_WAIT_CANCEL
int	wait_event_test(int fd);				// SDI_IOCTL_WAIT_EVENT
int	wait_status_test(int fd);				// SDI_IOCTL_WAIT_STATUS



#endif
