// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16SDI/16SDI_Linux_4.x.x.x_GSC_DN/samples/sbtest/query.c $
// $Rev: 51952 $
// $Date: 2022-10-25 08:36:47 -0500 (Tue, 25 Oct 2022) $

// 16SDI: Sample Application: source file

#include "main.h"



/******************************************************************************
*
*	Function:	query_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service SDI_IOCTL_QUERY. We test only the
*		overall service, not the values returned.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int query_test(int fd)
{
	s32	data;
	s32	count;
	int	errs;
	int	i;

	gsc_label("SDI_IOCTL_QUERY");
	errs	= sdi_query(fd, -1, 0, SDI_QUERY_COUNT, &count);

	if (count != (SDI_IOCTL_QUERY_LAST + 1))
	{
		errs	= 1;
		printf(	"FAIL <---  (expected %ld, got %ld, rebuild application)\n",
				(long) SDI_IOCTL_QUERY_LAST + 1,
				(long) count);
	}

	for (i = 0; (errs == 0) && (i <= SDI_IOCTL_QUERY_LAST); i++)
		errs	= sdi_query(fd, -1, 0, i, &data);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


