// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16SDI/16SDI_Linux_4.x.x.x_GSC_DN/utils/util_ch_grp_src.c $
// $Rev: 51943 $
// $Date: 2022-10-25 08:29:04 -0500 (Tue, 25 Oct 2022) $

// 16SDI: Utilities: source file

#include "main.h"



//*****************************************************************************
int	sdi_ch_grp_src_all(int fd, int index, int verbose, s32 set)
{
	int	errs;
	s32	qty		= 0;

	errs	= sdi_query(fd, -1, verbose, SDI_QUERY_CHANNEL_GPS, &qty);

	if (verbose)
		gsc_label_level_inc();

	if (qty > 0)
		errs	+= sdi_ch_grp_0_src(fd, index, verbose, set, NULL);

	if (qty > 1)
		errs	+= sdi_ch_grp_1_src(fd, index, verbose, set, NULL);

	if (qty > 2)
		errs	+= sdi_ch_grp_2_src(fd, index, verbose, set, NULL);

	if (qty > 3)
		errs	+= sdi_ch_grp_3_src(fd, index, verbose, set, NULL);

	if (verbose)
		gsc_label_level_dec();

	return(errs);
}



//*****************************************************************************
int	sdi_ch_grp_src_group(int fd, int index, int verbose, int group, s32 set, s32* get)
{
	int	errs;
	s32	qty		= 0;

	errs	= sdi_query(fd, -1, verbose, SDI_QUERY_CHANNEL_GPS, &qty);

	if (errs)
	{
		if (verbose)
			printf(" FAIL <---  (sdi_query() failure)\n");
	}
	else
	{
		if ((group + 1) <= qty)
		{
			switch (group)
			{
				case 0: errs	+= sdi_ch_grp_0_src(fd, index, verbose, set, get);	break;
				case 1: errs	+= sdi_ch_grp_1_src(fd, index, verbose, set, get);	break;
				case 2: errs	+= sdi_ch_grp_2_src(fd, index, verbose, set, get);	break;
				case 3: errs	+= sdi_ch_grp_3_src(fd, index, verbose, set, get);	break;
			}
		}
		else
		{
			errs++;

			if (verbose)
			{
				printf(" FAIL <---  (invalid channel group %d, qty %d)\n",
						(int) group,
						(int) qty);
			}
		}
	}

	return(errs);
}


